<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <meta http-equiv="X-UA-Compatible" content="ie=edge">
  <title>Document</title>
  <style>
    body {
      background-color: gray !important;
    }
  </style>
</head>
<body>
<button class="button" onclick="openNotf();">Open</button>
<button class="button" onclick="flyOpenNotf();">Fly and open</button>
<button class="button" onclick="HideNotf();">Hide</button>
<button class="button" onclick="CloseNotf();">Close</button>

  <div class="toast-notification">
    <div class="notification-icon"><img src="icons/telegram-icon.png"></div>
    <div class="notification-body">

      <div class="notification-content">
        <h5>Patrick A Lima</h5>
        <span>Neque porro quisquam est qui dolorem ipsum quia dolor sit amet, consectetur, adipisci velit</span>
      </div>
      
      <div class="notification-actions">
        <ul>
          <li class="action-items" onclick="CloseNotf();">Fechar</li>
        </ul>
      </div>
    
    </div>
  </div>
  
  <script>
    function init() {
      let notf = document.querySelector('.toast-notification');
      notf.addEventListener('transitionend', watchEvents);
      // notf.addEventListener('animationend', watchEvents);
      notf.style.width = 0;
      notf.classList.add('closed');
    }

    function watchEvents(evt) {
      let notfObj = document.querySelector('.toast-notification');
      console.log(evt)
      // Like System app, the transition is our state machine.
      if (evt.type == 'transitionend') {
        
        // We only process 'background-color' because all states have this
        // change.
        // if ((notfObj.propertyName !== 'background-color' &&
        //      notfObj.propertyName !== 'opacity' &&
        //      notfObj.propertyName !== 'width')) {
        //   return;
        // }
        
        if (notfObj.classList.contains('opening')) {
          notfObj.classList.add('opened');
          notfObj.classList.remove('opening');
        }  else if (notfObj.classList.contains('flying')) {
          notfObj.classList.remove('flying');
          openNotf();
        }

        // go back to initial state after hiding
        if (notfObj.classList.contains('hiding') || notfObj.classList.contains('closing')) {
          notfObj.classList.remove('opened');
          notfObj.classList.remove('opening');
          notfObj.classList.remove('closing');
          notfObj.classList.remove('flying');
          notfObj.classList.remove('hiding');
          notfObj.classList.add('closed');
          notfObj.style = '';
        }
      }
    }

    function openNotf() {
    let notfObj = document.querySelector('.toast-notification');

    // no operation during flying and hiding
    if (notfObj.classList.contains('flying') ||
        notfObj.classList.contains('hiding')) {
      return;
    }
    // If we get focus when we closing the group, we need to cancel the closing
    // state.
    notfObj.classList.remove('closed');
    notfObj.classList.remove('closing');
    notfObj.classList.add('opening');
    // change to opening
    notfObj.style.width = '400px';
    notfObj.style.bottom = '10px';
    }

    function flyOpenNotf() {
      let notfObj = document.querySelector('.toast-notification');

      if (notfObj.classList.contains('closed')) {
        notfObj.classList.add('flying');
        // notfObj.style.bottom = '10px';
      }
    }

    function HideNotf() {
      let notfObj = document.querySelector('.toast-notification');
      notfObj.classList.add('hiding');
    }

    function CloseNotf() {
      let notfObj = document.querySelector('.toast-notification');
      notfObj.classList.add('closing');
      notfObj.style.transform = 'translateX(120%)';
    }

    document.addEventListener('DOMContentLoaded', function() {
      init();
    });
  </script>
  <script src="../nuiverse.min.js"></script>
</body>
</html>